


import java.util.LinkedList;

/**
 * An implementation of EditableQueue using a LinkedList.
 * 
 * TODO implement according to assignment handout
 * 
 */
public class LLEditableQueue<E> implements EditableQueue<E> {

	/**
	 * LinkedList for implementing the queue.
	 */
	private LinkedList<E> queue;

	/**
	 * Constructs a new LLEditableQueue.
	 * 
	 */
	public LLEditableQueue() {
		queue = new LinkedList<E>();
	}

	/**
	 * Removes an element from the queue.
	 * 
	 * @param element
	 *            the element to be removed.
	 * @return true if the element was found and removed, false otherwise.
	 */
	public boolean remove(E element) {
		return queue.remove(element);
	}

	/**
	 * Retrieves the number of elements currently in the queue.
	 * 
	 * @return the number of elements currently in the queue.
	 */
	public int size() {
		return queue.size();
	}

	/**
	 * Tests if the queue is currently empty.
	 * 
	 * @return true if the queue is empty, false otherwise.
	 */
	public boolean isEmpty() {
		return queue.isEmpty();
	}

	/**
	 * Adds an element to the end of the queue.
	 * 
	 * @param element
	 *            the element to be added to the queue.
	 */
	public void enqueue(E element) {
		queue.addLast(element);
	}

	/**
	 * Removes an element from the front of the queue and returns it to the
	 * caller.
	 * 
	 * @return the element at the front of the queue.
	 */
	public E dequeue() {
		return queue.removeFirst();
	}

	/**
	 * Retrieves the element at the front of the queue without removing it.
	 * 
	 * @return the element at the front of the queue.
	 */
	public E front() {
		return queue.get(0);
	}

}
