


/**
 * An implementation of PureStack using Queues.
 * 
 */
public class QStack<E> implements PureStack<E> {

	/**
	 * Two queues to be used for implementing the stack.
	 */
	private PureQueue<E> queue1;

	private PureQueue<E> queue2;

	/**
	 * Constructs a new QStack.
	 * 
	 */
	public QStack() {
		queue1 = new LLPureQueue<E>();
		queue2 = new LLPureQueue<E>();
	}

	/**
	 * Retrieves the number of elements currently in the stack.
	 * 
	 * @return the number of elements currently in the stack.
	 */
	public int size() {
		return queue1.size();
	}

	/**
	 * Tests if the stack is empty.
	 * 
	 * @return true if there are no elements in the stack, false otherwise.
	 */
	public boolean isEmpty() {
		return queue1.isEmpty();
	}

	/**
	 * Inserts an element on the top of the stack.
	 * 
	 * @param element
	 *            the element to be inserted.
	 */
	public void push(E element) {
		queue1.enqueue(element);
	}

	/**
	 * Removes an element from the top of the stack and returns it to the
	 * caller.
	 * 
	 * @return the top of the stack.
	 */
	public E pop() {

		// TODO implement this method 

		/*
		 * Dequeue all the elements, placing them on the auxialiary queue
		 * (queue2). The last element dequeued is the top of the stack and is
		 * the element to be returned to the caller.
		 */

		E elt = queue1.dequeue();
		while (queue1.size() > 0) {
			queue2.enqueue(elt);
			elt = queue1.dequeue();
		}

		// swap the roles of queue1 and queue2.
		PureQueue<E> tmp = queue1;
		queue1 = queue2;
		queue2 = tmp;

		return elt;
	}

	/**
	 * Retrieves the top element of the stack without removing it.
	 * 
	 * @return the top element of the stack.
	 */
	public E peek() {
		// You do not need to implement this function

		throw new UnsupportedOperationException();
	}

}
